/*
	Example of SelfExtract class usage.

	Example code does hold minimal error checking.
	Please give valid information in order to avoid confusion.
*/
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <stdio.h>
#include <tchar.h>
#include "SelfExtract.h"

int _tmain(int argc, _TCHAR* argv[])
{
	SelfExtract self;

	if (self.checkSignature())
	{
        puts("Detaching internal file, please wait...");
		// detecting output diretory.
		// if no parameter then current directory.
		char *outDir = 0;
		if (argc > 1)
		{
			outDir = argv[1];
		}
		char detached[MAX_PATH];
		// detaching internal file.
		self.detachFile(outDir, detached, MAX_PATH);
        printf("file %s detached successfully.\n", detached);
		return 0;
	}
	// if no file is attached.
	else
	{
		// missing parameter(s) - showing command line parameters.
		if (argc < 3)
		{
			puts("SelfExtract class example utility, by Nir Dremer");
			printf("Usage: %s resultFile attacheFile\n", argv[0]);
			puts("resultFile is executable you want to create that will be self extracted.");
			puts("attacheFile is the file you want to attach to resultFile.");
			return 0;
		}

		printf("Creating %s, please wait..", argv[1]);
		// copying this file as a header for the self extracted executable.
		CopyFile(argv[0], argv[1], true);
		self.setFilename(argv[1]);
		// attaching the attache file.
		self.attachFile(argv[2]);
		printf("Process completed, execute %s to detach.", argv[1]);
	}
	return 0;
}